#ifndef CHIP_CLK_H
#define CHIP_CLK_H

#include "chip_clk_defs.h"
#include "chip_config.h"
#include "chip_devtype_spec_features.h"
#include "chip_cfg_defs.h"


#define CHIP_CLK_HSE_EN  (CHIP_CLK_HSE_MODE != CHIP_CLK_EXTMODE_DIS)
#define CHIP_CLK_LSE_EN  (CHIP_CLK_LSE_MODE != CHIP_CLK_EXTMODE_DIS)




#if CHIP_CLK_HSE_EN
    #ifndef CHIP_CFG_CLK_HSE_FREQ
        #error HSE clock frequency is not specified
    #endif
    #define CHIP_CLK_HSE_FREQ       CHIP_CFG_CLK_HSE_FREQ

#ifdef CHIP_CFG_CLK_HSE_CSS_EN
    #define CHIP_CLK_HSE_CSS_EN CHIP_CFG_CLK_HSE_CSS_EN
#else
    #define CHIP_CLK_HSE_CSS_EN 0
#endif
#else
    #define CHIP_CLK_HSE_FREQ       0
    #define CHIP_CLK_HSE_CSS_EN     0
#endif


#if CHIP_CLK_PLL_EN
    #define CHIP_CLK_PLL_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_PLL_SRC)
#if CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_PLLIN_FREQ    CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_PLLIN_EN      CHIP_CLK_HSI_EN
#elif CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_PLLIN_FREQ    CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_PLLIN_EN      CHIP_CLK_HSE_EN
#elif CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSI48_ID
    #define CHIP_CLK_PLLIN_FREQ    CHIP_CLK_HSI48_FREQ
    #define CHIP_CLK_PLLIN_EN      CHIP_CLK_HSI48_EN
#else
    #define CHIP_CLK_PLLIN_FREQ    0
    #define CHIP_CLK_PLLIN_EN      0
#endif

#define CHIP_CLK_PLL_FREQ          ((CHIP_CLK_PLLIN_FREQ / CHIP_CLK_PLL_PREDIV)  * CHIP_CLK_PLL_MUL)
#else
#define CHIP_CLK_PLLIN_FREQ    0
#define CHIP_CLK_PLLIN_EN      0
#define CHIP_CLK_PLL_FREQ      0
#endif



#define CHIP_CLK_SYS_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_SYS_SRC)
#if CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSI_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSE_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSE_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_PLL_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_PLL_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_PLL_EN
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSI48_ID
    #define CHIP_CLK_SYS_FREQ CHIP_CLK_HSI48_FREQ
    #define CHIP_CLK_SYS_EN   CHIP_CLK_HSI48_EN
#else
    #define CHIP_CLK_SYS_FREQ 0
    #define CHIP_CLK_SYS_EN   0
#endif




#define CHIP_CLK_AHB_FREQ       (CHIP_CLK_SYS_FREQ / CHIP_CLK_AHB_DIV)
#define CHIP_CLK_APB_FREQ       (CHIP_CLK_AHB_FREQ / CHIP_CLK_APB_DIV) /* частота шины APB1 */
#define CHIP_CLK_APB1_FREQ      CHIP_CLK_APB_FREQ /* частота шины APB1 */
#define CHIP_CLK_APB2_FREQ      CHIP_CLK_APB_FREQ /* частота шины APB2 */


#define CHIP_CLK_AHB_EN         1
#define CHIP_CLK_APB_EN         1
#define CHIP_CLK_APB1_EN        1
#define CHIP_CLK_APB2_EN        1

/* псевдонимы, используемые в документации */
#define CHIP_CLK_HCLK_FREQ      CHIP_CLK_AHB_FREQ
#define CHIP_CLK_HCLK_EN        CHIP_CLK_AHB_EN
#define CHIP_CLK_PCLK_FREQ      CHIP_CLK_APB_FREQ
#define CHIP_CLK_PCLK_EN        CHIP_CLK_APB_EN



#define CHIP_CLK_CPU_FREQ        CHIP_CLK_AHB_FREQ
#define CHIP_CLK_SYSTICK_FREQ    CHIP_CLK_AHB_FREQ /* есть опция использовать AHB_FREQ/8, но в CMSIS она не используется */

#define CHP_CLK_FLASH_FREQ       CHIP_CLK_HSI_FREQ


#if CHIP_CLK_MCO_EN
    #define CHIP_CLK_MCO_SRC_ID   CHIP_CLK_ID_VAL(CHIP_CLK_MCO_SRC)

    #if CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI14_ID
        #define CHIP_CLK_MCO_SRC_FREQ   CHIP_CLK_HSI14_FREQ
        #define CHIP_CLK_MCO_SRC_EN     CHIP_CLK_HSI14_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSI_ID
        #define CHIP_CLK_MCO_SRC_FREQ   CHIP_CLK_LSI_FREQ
        #define CHIP_CLK_MCO_SRC_EN     CHIP_CLK_LSI_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSE_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_LSE_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_LSE_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_SYS_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_SYS_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSI_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSI_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSE_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSE_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_PLL_ID
        #define CHIP_CLK_MCO_SRC_FREQ (CHIP_CLK_PLL_FREQ/CHIP_CLK_MCO_PLL_DIV)
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_PLL_EN
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI48_ID
        #define CHIP_CLK_MCO_SRC_FREQ CHIP_CLK_HSI48_FREQ
        #define CHIP_CLK_MCO_SRC_EN   CHIP_CLK_HSI48_EN
    #else
        #define CHIP_CLK_MCO_SRC_FREQ 0
        #define CHIP_CLK_MCO_SRC_EN   0
    #endif
    #define CHIP_CLK_MCO_FREQ   (CHIP_CLK_MCO_SRC_FREQ/CHIP_CLK_MCO_DIV)
#endif


/* частота таймеров в 2 раза больше частоты шины APB, если только делитель
 * для ABP не равен 1 */
#if CHIP_CLK_APB_DIV == 1
    #define CHIP_CLK_APB_TIM_FREQ   CHIP_CLK_APB_FREQ
#else
    #define CHIP_CLK_APB_TIM_FREQ   (2*CHIP_CLK_APB_FREQ)
#endif
#define CHIP_CLK_TIM1_FREQ      CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM2_FREQ      CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM3_FREQ      CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM6_FREQ      CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM7_FREQ      CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM14_FREQ     CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM15_FREQ     CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM16_FREQ     CHIP_CLK_APB_TIM_FREQ
#define CHIP_CLK_TIM17_FREQ     CHIP_CLK_APB_TIM_FREQ

#define CHIP_CLK_I2C1_SRC_ID      CHIP_CLK_ID_VAL(CHIP_CLK_I2C1_SRC)
#if CHIP_CLK_I2C1_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_I2C1_FREQ    CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_I2C1_SRC_EN  CHIP_CLK_HSI_EN
#elif CHIP_CLK_I2C1_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_CLK_I2C1_FREQ    CHIP_CLK_SYS_FREQ
    #define CHIP_CLK_I2C1_SRC_EN  CHIP_CLK_SYS_EN
#else
    #define CHIP_CLK_I2C1_FREQ 0
#endif

#define CHIP_CLK_USART1_SRC_ID      CHIP_CLK_ID_VAL(CHIP_CLK_USART1_SRC)
#if CHIP_CLK_USART1_SRC_ID == CHIP_CLK_APB_ID
    #define CHIP_CLK_USART1_FREQ    CHIP_CLK_APB_FREQ
    #define CHIP_CLK_USART1_SRC_EN  CHIP_CLK_APB_EN
#elif CHIP_CLK_USART1_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_CLK_USART1_FREQ    CHIP_CLK_SYS_FREQ
    #define CHIP_CLK_USART1_SRC_EN  CHIP_CLK_SYS_EN
#elif CHIP_CLK_USART1_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_USART1_FREQ    CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_USART1_SRC_EN  CHIP_CLK_HSI_EN
#elif CHIP_CLK_USART1_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_USART1_FREQ    CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_USART1_SRC_EN  CHIP_CLK_LSE_EN
#else
    #define CHIP_CLK_USART1_FREQ 0
#endif

#define CHIP_CLK_USART2_SRC_ID      CHIP_CLK_ID_VAL(CHIP_CLK_USART2_SRC)
#if CHIP_CLK_USART2_SRC_ID == CHIP_CLK_APB_ID
    #define CHIP_CLK_USART2_FREQ    CHIP_CLK_APB_FREQ
    #define CHIP_CLK_USART2_SRC_EN  CHIP_CLK_APB_EN
#elif CHIP_CLK_USART2_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_CLK_USART2_FREQ    CHIP_CLK_SYS_FREQ
    #define CHIP_CLK_USART2_SRC_EN  CHIP_CLK_SYS_EN
#elif CHIP_CLK_USART2_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_USART2_FREQ    CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_USART2_SRC_EN  CHIP_CLK_HSI_EN
#elif CHIP_CLK_USART2_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_USART2_FREQ    CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_USART2_SRC_EN  CHIP_CLK_LSE_EN
#else
    #define CHIP_CLK_USART2_FREQ 0
#endif

#define CHIP_CLK_USART3_SRC_ID      CHIP_CLK_ID_VAL(CHIP_CLK_USART3_SRC)
#if CHIP_CLK_USART3_SRC_ID == CHIP_CLK_APB_ID
    #define CHIP_CLK_USART3_FREQ    CHIP_CLK_APB_FREQ
    #define CHIP_CLK_USART3_SRC_EN  CHIP_CLK_APB_EN
#elif CHIP_CLK_USART3_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_CLK_USART3_FREQ    CHIP_CLK_SYS_FREQ
    #define CHIP_CLK_USART3_SRC_EN  CHIP_CLK_SYS_EN
#elif CHIP_CLK_USART3_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_CLK_USART3_FREQ    CHIP_CLK_HSI_FREQ
    #define CHIP_CLK_USART3_SRC_EN  CHIP_CLK_HSI_EN
#elif CHIP_CLK_USART3_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_USART3_FREQ    CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_USART3_SRC_EN  CHIP_CLK_LSE_EN
#else
    #define CHIP_CLK_USART3_FREQ 0
#endif

#define CHIP_CLK_USART4_FREQ        CHIP_CLK_APB1_FREQ
#define CHIP_CLK_USART5_FREQ        CHIP_CLK_APB1_FREQ
#define CHIP_CLK_USART6_FREQ        CHIP_CLK_APB2_FREQ
#define CHIP_CLK_USART7_FREQ        CHIP_CLK_APB2_FREQ
#define CHIP_CLK_USART8_FREQ        CHIP_CLK_APB2_FREQ


#define CHIP_CLK_HSI_DIV244_FREQ    (CHIP_CLK_HSI_FREQ/244)
#define CHIP_CLK_HSI_DIV244_EN      CHIP_CLK_HSI_EN

#define CHIP_CLK_CEC_SRC_ID         CHIP_CLK_ID_VAL(CHIP_CLK_CEC_SRC)
#if CHIP_CLK_CEC_SRC_ID == CHIP_CLK_HSI_DIV244_ID
    #define CHIP_CLK_CEC_FREQ       CHIP_CLK_HSI_DIV244_FREQ
    #define CHIP_CLK_CEC_SRC_EN     CHIP_CLK_HSI_DIV244_EN
#elif CHIP_CLK_CEC_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_CLK_CEC_FREQ       CHIP_CLK_LSE_FREQ
    #define CHIP_CLK_CEC_SRC_EN     CHIP_CLK_LSE_EN
#else
    #define CHIP_CLK_CEC_FREQ       0
#endif

#define CHIP_CLK_USB_SRC_ID         CHIP_CLK_ID_VAL(CHIP_CLK_USB_SRC)
#if CHIP_CLK_USB_SRC_ID == CHIP_CLK_HSI48_ID
    #define CHIP_CLK_USB_FREQ       CHIP_CLK_HSI48_FREQ
    #define CHIP_CLK_USB_SRC_EN     CHIP_CLK_HSI48_EN
#elif CHIP_CLK_USB_SRC_ID == CHIP_CLK_PLL_ID
    #define CHIP_CLK_USB_FREQ       CHIP_CLK_PLL_FREQ
    #define CHIP_CLK_USB_SRC_EN     CHIP_CLK_PLL_EN
#else
    #define CHIP_CLK_USB_FREQ       0
#endif

#define CHIP_CLK_I2S1_FREQ          CHIP_CLK_SYS_FREQ
#define CHIP_CLK_I2S2_FREQ          CHIP_CLK_SYS_FREQ

#define CHIP_CLK_SPI1_FREQ          CHIP_CLK_APB2_FREQ
#define CHIP_CLK_SPI2_FREQ          CHIP_CLK_APB1_FREQ
#define CHIP_CLK_I2C2_FREQ          CHIP_CLK_APB1_FREQ
#define CHIP_CLK_CAN_FREQ           CHIP_CLK_APB1_FREQ
#define CHIP_CLK_TSC_FREQ           CHIP_CLK_AHB_FREQ
#define CHIP_CLK_CRS_FREQ           CHIP_CLK_HSI48

#endif // CHIP_CLK_H
